## sbcl 2.6.2

=== crossbuild-runner/Makefile ===
SBCL=src/runtime/sbcl
ARGS=--core output/sbcl.core --noinform --disable-debugger --noprint --no-userinit --no-sysinit
SCRIPT1=crossbuild-runner/pass-1.lisp
SCRIPT2=crossbuild-runner/pass-2.lisp
DEPS1=crossbuild-runner/pass-1.lisp src/cold/build-order.lisp-expr

obj/xbuild/arm/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) arm arm "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :LITTLE-ENDIAN :LARGEFILE)" < $(SCRIPT1)
obj/xbuild/arm.core: obj/xbuild/arm/xc.core
	$(SBCL) $(ARGS) arm < $(SCRIPT2)

obj/xbuild/arm64/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) arm64 arm64 "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :LITTLE-ENDIAN :SB-THREAD)" < $(SCRIPT1)
obj/xbuild/arm64.core: obj/xbuild/arm64/xc.core
	$(SBCL) $(ARGS) arm64 < $(SCRIPT2)

obj/xbuild/arm64-darwin/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) arm64-darwin arm64 "(:DARWIN :BSD :UNIX :MACH-O :LITTLE-ENDIAN :SB-THREAD :DARWIN-JIT :OS-PROVIDES-CLOCK-GETTIME)" < $(SCRIPT1)
obj/xbuild/arm64-darwin.core: obj/xbuild/arm64-darwin/xc.core
	$(SBCL) $(ARGS) arm64-darwin < $(SCRIPT2)

obj/xbuild/arm64-reloc/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) arm64-reloc arm64 "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :LITTLE-ENDIAN :SB-THREAD :RELOCATABLE-STATIC-SPACE :IMMOBILE-SPACE)" < $(SCRIPT1)
obj/xbuild/arm64-reloc.core: obj/xbuild/arm64-reloc/xc.core
	$(SBCL) $(ARGS) arm64-reloc < $(SCRIPT2)

obj/xbuild/arm64-immobile-space/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) arm64-immobile-space arm64 "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :LITTLE-ENDIAN :SB-THREAD :IMMOBILE-SPACE)" < $(SCRIPT1)
obj/xbuild/arm64-immobile-space.core: obj/xbuild/arm64-immobile-space/xc.core
	$(SBCL) $(ARGS) arm64-immobile-space < $(SCRIPT2)

obj/xbuild/mips/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) mips mips "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :LARGEFILE :LITTLE-ENDIAN)" < $(SCRIPT1)
obj/xbuild/mips.core: obj/xbuild/mips/xc.core
	$(SBCL) $(ARGS) mips < $(SCRIPT2)

obj/xbuild/loongarch64/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) loongarch64 loongarch64 "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :64-BIT :LITTLE-ENDIAN :SB-THREAD)" < $(SCRIPT1)
obj/xbuild/loongarch64.core: obj/xbuild/loongarch64/xc.core
	$(SBCL) $(ARGS) loongarch64 < $(SCRIPT2)

obj/xbuild/ppc/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) ppc ppc "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :BIG-ENDIAN)" < $(SCRIPT1)
obj/xbuild/ppc.core: obj/xbuild/ppc/xc.core
	$(SBCL) $(ARGS) ppc < $(SCRIPT2)

obj/xbuild/ppc-thread/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) ppc-thread ppc "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :BIG-ENDIAN :SB-THREAD)" < $(SCRIPT1)
obj/xbuild/ppc-thread.core: obj/xbuild/ppc-thread/xc.core
	$(SBCL) $(ARGS) ppc-thread < $(SCRIPT2)

obj/xbuild/ppc64/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) ppc64 ppc64 "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :PPC64 :BIG-ENDIAN)" < $(SCRIPT1)
obj/xbuild/ppc64.core: obj/xbuild/ppc64/xc.core
	$(SBCL) $(ARGS) ppc64 < $(SCRIPT2)

obj/xbuild/riscv/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) riscv riscv "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :64-BIT :LITTLE-ENDIAN :SB-THREAD)" < $(SCRIPT1)
obj/xbuild/riscv.core: obj/xbuild/riscv/xc.core
	$(SBCL) $(ARGS) riscv < $(SCRIPT2)

obj/xbuild/sparc/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) sparc sparc "(:UNIX :LINUX :ELF :OS-PROVIDES-CLOCK-GETTIME :BIG-ENDIAN)" < $(SCRIPT1)
obj/xbuild/sparc.core: obj/xbuild/sparc/xc.core
	$(SBCL) $(ARGS) sparc < $(SCRIPT2)

obj/xbuild/sparc-sunos/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) sparc-sunos sparc "(:BIG-ENDIAN :UNIX :SUNOS :ELF :OS-PROVIDES-CLOCK-GETTIME)" < $(SCRIPT1)
obj/xbuild/sparc-sunos.core: obj/xbuild/sparc-sunos/xc.core
	$(SBCL) $(ARGS) sparc-sunos < $(SCRIPT2)

obj/xbuild/x86/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86 x86 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :LARGEFILE (NOT :SB-EVAL) :SB-FASTEVAL)" < $(SCRIPT1)
obj/xbuild/x86.core: obj/xbuild/x86/xc.core
	$(SBCL) $(ARGS) x86 < $(SCRIPT2)

obj/xbuild/x86-ascii/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-ascii x86 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :LARGEFILE (NOT :SB-UNICODE))" < $(SCRIPT1)
obj/xbuild/x86-ascii.core: obj/xbuild/x86-ascii/xc.core
	$(SBCL) $(ARGS) x86-ascii < $(SCRIPT2)

obj/xbuild/x86-thread/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-thread x86 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :LARGEFILE :SB-THREAD)" < $(SCRIPT1)
obj/xbuild/x86-thread.core: obj/xbuild/x86-thread/xc.core
	$(SBCL) $(ARGS) x86-thread < $(SCRIPT2)

obj/xbuild/x86-linux/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-linux x86 "(:LITTLE-ENDIAN :LARGEFILE :SB-THREAD :LINUX :UNIX :ELF :SB-THREAD :OS-PROVIDES-CLOCK-GETTIME)" < $(SCRIPT1)
obj/xbuild/x86-linux.core: obj/xbuild/x86-linux/xc.core
	$(SBCL) $(ARGS) x86-linux < $(SCRIPT2)

obj/xbuild/x86-64/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-64 x86-64 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :AVX2 :GENCGC :SB-SIMD-PACK :SB-SIMD-PACK-256)" < $(SCRIPT1)
obj/xbuild/x86-64.core: obj/xbuild/x86-64/xc.core
	$(SBCL) $(ARGS) x86-64 < $(SCRIPT2)

obj/xbuild/x86-64-linux/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-64-linux x86-64 "(:LINUX :UNIX :ELF :LITTLE-ENDIAN :AVX2 :GENCGC :SB-SIMD-PACK :SB-SIMD-PACK-256 (NOT :SB-EVAL) :SB-FASTEVAL :OS-PROVIDES-CLOCK-GETTIME)" < $(SCRIPT1)
obj/xbuild/x86-64-linux.core: obj/xbuild/x86-64-linux/xc.core
	$(SBCL) $(ARGS) x86-64-linux < $(SCRIPT2)

obj/xbuild/x86-64-darwin/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-64-darwin x86-64 "(:DARWIN :BSD :UNIX :MACH-O :LITTLE-ENDIAN :AVX2 :GENCGC :SB-SIMD-PACK :SB-SIMD-PACK-256 :OS-PROVIDES-CLOCK-GETTIME)" < $(SCRIPT1)
obj/xbuild/x86-64-darwin.core: obj/xbuild/x86-64-darwin/xc.core
	$(SBCL) $(ARGS) x86-64-darwin < $(SCRIPT2)

obj/xbuild/x86-64-imm/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-64-imm x86-64 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :AVX2 :GENCGC :SB-SIMD-PACK :SB-SIMD-PACK-256 :IMMOBILE-SPACE (NOT :SB-UNICODE))" < $(SCRIPT1)
obj/xbuild/x86-64-imm.core: obj/xbuild/x86-64-imm/xc.core
	$(SBCL) $(ARGS) x86-64-imm < $(SCRIPT2)

obj/xbuild/x86-64-permgen/xc.core: $(DEPS1)
	$(SBCL) $(ARGS) x86-64-permgen x86-64 "(:WIN32 :SB-THREAD :SB-SAFEPOINT :LITTLE-ENDIAN :AVX2 :GENCGC :SB-SIMD-PACK :SB-SIMD-PACK-256 :PERMGEN)" < $(SCRIPT1)
obj/xbuild/x86-64-permgen.core: obj/xbuild/x86-64-permgen/xc.core
	$(SBCL) $(ARGS) x86-64-permgen < $(SCRIPT2)

=== debian/changelog ===
sbcl (2:2.6.2-1) unstable; urgency=medium

  * Update to new upstream version 2.6.2.
  * Remove pkg.sbcl.bootstrap profile.
    The patch was not Policy-compliant because one build-dep had both
    negated and unnegated architectures.
    Revert the change until someone can redo it.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 01 Mar 2026 17:55:05 +0000

sbcl (2:2.6.1-1) unstable; urgency=medium

  * Update to new upstream version 2.6.1.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 05 Feb 2026 14:38:38 +0000

sbcl (2:2.6.0-2) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Add pkg.sbcl.bootstrap profile (Closes: #1124619).

  [ Sean Whitton ]
  * Drop remaining references to kfreebsd in debian/.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 06 Jan 2026 15:14:41 +0000

=== debian/control ===
Source: sbcl
Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
Uploaders: Sean Whitton <spwhitton@spwhitton.name>, 
           Peter Van Eynde <pvaneynd@debian.org> 
Section: lisp
Priority: optional
Build-Depends: debhelper-compat (= 13),
               debhelper (>= 12.8~),
# Arch list to keep in sync with debian/rules
               clisp [!amd64 !arm64 !armel !armhf !i386 !powerpc !ppc64 !ppc64el !sh4],
               ecl [sh4],
               sbcl [amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el],
               sbcl-source,
               texinfo,
               libzstd-dev,
               texlive-extra-utils,
               texlive,
               graphviz,
               ghostscript,
               texlive-plain-generic,
               texlive-font-utils,
               cm-super-minimal,
               time,
               netbase,
               ed,
               strace
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/common-lisp-team/sbcl
Vcs-Git: https://salsa.debian.org/common-lisp-team/sbcl.git
Homepage: http://www.sbcl.org
Rules-Requires-Root: no

Package: sbcl
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: binfmt-support | systemd
Suggests: sbcl-doc,
          sbcl-source,
          slime
Breaks: cl-asdf (<< 2:3.3.3-4~),
        cl-cffi (<< 1:0.22.1-1~),
        cl-nibbles (<< 20210520.gitdad2524-1~)
Provides: lisp-compiler,
          ${sbcl:fasl-version}
Description: Common Lisp compiler and development system
 SBCL is a development environment for the ANSI Common Lisp language.
 It provides a native-code compiler and an integrated debugger, as well
 as all the features in the ANSI specification.
 .
 SBCL also contains other extensions to the ANSI specification, including
 a foreign-function interface, a pseudo-server API, user-extensible
 stream functionality, a Meta-Object Protocol, and an ability to run
 external processes.
 .
 To browse SBCL source definitions with development environments,
 install the sbcl-source package. For documentation on SBCL's usage
 and internals, the package sbcl-doc is provided.

Package: sbcl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for Steel Bank Common Lisp
 This package provides documentation for SBCL -- a development
 environment for the ANSI Common Lisp language.
 .
 The documents in this package cover SBCL-specific extensions to the
 language, explain how to use this Common Lisp implementation and how
 it differs from the ANSI standard.
 .
 The manual about SBCL's internals is also included in this package
 and may be of interest for people who intent to work with SBCL's
 source code.

Package: sbcl-source
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Source code files for SBCL
 This package provides the source code for SBCL -- a development
 environment for the ANSI Common Lisp language.
 .
 The source code is useful in conjunction with development
 environments and debuggers like SLIME, that allow macro expansion and
 lookup of source definitions.
 .
 Installing this package enables your source browser to dig deeply
 into the core of Steel Bank Common Lisp.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE=1

# Try to build with clisp by default on archs for which sbcl has not yet been bootstrapped
# (or with ecl if clisp is not available).
# Those lists must be kept in sync with the Build-Depends field.
# As soon as a new arch is bootstrapped, the lists should be updated.
# See https://bugs.debian.org/954031
ifeq (,$(filter amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el, $(DEB_HOST_ARCH)))
ifneq (,$(filter sh4, $(DEB_HOST_ARCH)))
        BOOTSTRAPLISP := /usr/bin/ecl --norc
else
	BOOTSTRAPLISP := /usr/bin/clisp -norc
endif
endif

ifeq (,$(BOOTSTRAPLISP))
	BOOTSTRAPLISP := /usr/bin/sbcl --disable-debugger --no-sysinit --no-userinit
endif

# Fix architecture detection on ppc64, see #939453
ifeq (ppc64,$(DEB_HOST_ARCH))
	export SBCL_ARCH=ppc64
endif

# Fix architecture detection on i386 in Salsa CI
ifeq (i386,$(DEB_HOST_ARCH))
	export SBCL_ARCH=x86
endif

FEATURES := --fancy

ifneq (,$(filter amd64 i386 armel armhf arm64, $(DEB_HOST_ARCH)))
	FEATURES += --with-sb-linkable-runtime
endif

%:
	dh $@

override_dh_auto_configure:
	# See doc/PACKAGING-SBCL.txt
	echo "\"$(DEB_VERSION_UPSTREAM).debian\"" > version.lisp-expr

override_dh_auto_build:
	# Create stage 1
	./make.sh --xc-host="$(BOOTSTRAPLISP)" --prefix=$(CURDIR)/stage1 $(FEATURES)
	./install.sh
	chmod 100 stage1 # Make stage 1 unreadable (only executable), to avoid messing with the stage 2
	./clean.sh

	# Create stage 2
	./make.sh --xc-host="$(CURDIR)/stage1/bin/sbcl --disable-debugger --no-sysinit --no-userinit" --prefix=/usr $(FEATURES)

	# Set the source location in core image
	HOME="$(CURDIR)" src/runtime/sbcl --core output/sbcl.core --no-sysinit --no-userinit \
                         --eval '(sb-ext:set-sbcl-source-location "/usr/share/sbcl-source/")' \
	                 --eval '(sb-ext:save-lisp-and-die "output/sbcl.core")'

	chmod 700 stage1 # Do not leave stage1 unreadable (to avoid FTBFS on some Ubuntu buildds)

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	make -C doc/internals all html
	make -j1 -C doc/manual
endif

# Run the testsuite, and fail on errors only on amd64, arm64 and i386
override_dh_auto_test:
	{ cd tests && ./run-tests.sh; } || { [ "$(DEB_HOST_ARCH)" != amd64 ] && [ "$(DEB_HOST_ARCH)" != arm64 ] && [ "$(DEB_HOST_ARCH)" != i386 ]; }

override_dh_auto_clean:
	-chmod 700 stage1
	rm -rf stage1
	./clean.sh
	rm -f version.lisp-expr

override_dh_auto_install:
	INSTALL_ROOT="$(CURDIR)/debian/tmp/usr" ./install.sh

execute_after_dh_install-arch:
	cp debian/binfmt debian/sbcl/usr/share/binfmts/sbcl

execute_after_dh_install-indep:
	find debian/sbcl-source/usr/share/sbcl-source -type f \( -name \*.fasl -or -name \*.o -or -name \*.log -or -name \*.so -or -name *.a -or -name a.out -or -name LICENSE -or -name COPYING \) -delete
	rm -f debian/sbcl-source/usr/share/sbcl-source/src/runtime/sbcl \
		debian/sbcl-source/usr/share/sbcl-source/src/runtime/sbcl.nm \
		debian/sbcl-source/usr/share/sbcl-source/src/runtime/shrinkwrap-sbcl \
		debian/sbcl-source/usr/share/sbcl-source/src/runtime/heap-reloc-test \
		debian/sbcl-source/usr/share/sbcl-source/src/runtime/ldb

execute_before_dh_gencontrol:
	# Add the FASL version of this release to substvars
	HOME="$(CURDIR)" src/runtime/sbcl --core output/sbcl.core --no-sysinit --no-userinit --load "debian/fasl-version.lisp"
